/*******************************************************************************
 * FoxItemCacheUnlockLevels generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxItemCacheUnlockLevels extends FoxItemCacheBase
    native;

var private transient array<UnlockLevelMetaData> CachedUnlockLevels;
var private transient bool bIsRefreshing;
var private transient string RankNameFormatString;
var private const localized string LocStringPlayerLevel;

function Initialize(UniqueNetId NetId)
{
    super.Initialize(NetId);
    //return;    
}

function Cleanup()
{
    super.Cleanup();
    CachedUnlockLevels.Length = 0;
    bIsRefreshing = false;
    //return;    
}

function SetupDelegates()
{
    // End:0x64
    if(NotEqual_InterfaceInterface(StoreInterface, (none)) && !bInitialized)
    {
        StoreInterface.AddQueryUnlockLevelCompleteDelegate(0, ReadUnlockLevelsComplete);
    }
    //return;    
}

function CleanupDelegates()
{
    // End:0x62
    if(NotEqual_InterfaceInterface(StoreInterface, (none)) && bInitialized)
    {
        StoreInterface.ClearQueryUnlockLevelCompleteDelegate(0, ReadUnlockLevelsComplete);
    }
    //return;    
}

// Export UFoxItemCacheUnlockLevels::execPopulateUnlockLevels(FFrame&, void* const)
native function PopulateUnlockLevels();

// Export UFoxItemCacheUnlockLevels::execPopulateRankData(FFrame&, void* const)
native static final function bool PopulateRankData(const string UnlockLevelData);

protected function bool RefreshCache()
{
    // End:0x29
    if((IsDirty()) && !bIsRefreshing)
    {
        return ReadUnlockLevels();
    }
    return true;
    //return ReturnValue;    
}

private final function bool ReadUnlockLevels()
{
    bIsRefreshing = NotEqual_InterfaceInterface(StoreInterface, (none)) && StoreInterface.QueryUnlockLevels();
    // End:0x68
    if(!bIsRefreshing)
    {
        ReadUnlockLevelsComplete("");
    }
    return bIsRefreshing;
    //return ReturnValue;    
}

private final function ReadUnlockLevelsComplete(string UnlockLevelData)
{
    // End:0x38
    if(UnlockLevelData != "")
    {
        ParseFromXML(CachedUnlockLevels, UnlockLevelData);
        bIsDirty = false;
    }
    bIsRefreshing = false;
    PopulateUnlockLevels();
    //return;    
}

// Export UFoxItemCacheUnlockLevels::execParseFromXML(FFrame&, void* const)
private native final function bool ParseFromXML(out array<UnlockLevelMetaData> OutUnlockLevels, const string UnlockLevelData);

defaultproperties
{
    RankNameFormatString="RankName_%02d"
    LocStringPlayerLevel="AGENT LEVEL"
}